/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - August 21, 2003.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2003
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

// Our gobal stuff goes here
var tree = null;
var tabbrowser = null;
var stringBundle = null;
var busyTabs = -1;

////////////////////////////////////////////////////////////////////////////////
function getTreerowByOrdinal(aOrdinal)
{
  var rows = tree.treeBoxObject.view.rowCount;
  for (var i = 0; i < rows; i++) {
    var treerow = document.getElementById("tm-tab-"+i+1);
    if (tree.view.getCellText(i, "tm-ordinal") == aOrdinal) {
      return i;
    }
  }
  return -1;
}
////////////////////////////////////////////////////////////////////////////////
function updateTabManager(aTab, aImage, aLabel, aURL, aReloadInterval)
{
  var ordinal = aTab.ordinal;
  var row = getTreerowByOrdinal(ordinal);
  var data = {};
  // alert(aTab.ordinal+"\n"+aImage+"\n"+aLabel+"\n"+aURL+"\n"+aReloadInterval);
  if (row != -1) {
    alert(tree.view.isEditable(1, "tm-label"));
    try {
    data.value = aLabel;
    tree.view.setCellText(row, "tm-label", "aLabel");
    data.value = aImage;
    tree.view.setCellText(row, "tm-image", "aImage");
    data.value = aURL;
    tree.view.setCellText(row, "tm-location", "aURL");
    data.value = aReloadInterval;
    tree.view.setCellText(row, "tm-interval", "aReloadInterval");
   } catch(e) { dump(e); }
  }
}
////////////////////////////////////////////////////////////////////////////////
function Test()
{
  var tab = tabbrowser.selectedTab;
  updateTabManager(tab, tab.getAttribute("image"), tab.getAttribute("label"), 
                   "http://multizilla.mozdev.org", tab.mReloadInterval);
}
////////////////////////////////////////////////////////////////////////////////
function getLastActiveBrowserWindow()
{
  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
  var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  var window = windowManagerInterface.getMostRecentWindow("navigator:browser");
  return window;
}
////////////////////////////////////////////////////////////////////////////////
function tabListInit()
{
  var tabList = tabbrowser.mTabList;
  var tabs = tabList.length;
  var URL = null;
  // var windowtype = "window-0";

  // addContainer("TEST");
  for (var i = 0; i < tabs; i++) {
    var tab = tabList[i];
    var browser = tabbrowser.getBrowserForTab(tab);
    var favicon = tab.getAttribute("image");
    // Use user friendly formats for Reload Intervals like 3600/60000
    var reloadInterval = tab.mReloadInterval/1000 || 0;
    if (reloadInterval > 59)
      reloadInterval = reloadInterval/60 + " min";
    else reloadInterval = reloadInterval ? reloadInterval + " sec" : "";

    if (tab.hasAttribute("busy")) {
      busyTabs++;
      favicon = "chrome://multiviews/skin/icons/color/red.gif";
    }
    else if (!favicon)
      favicon = "chrome://multiviews/skin/icons/color/green.gif";
    var label = tab.getAttribute("label");

    try {
      URL = browser.webNavigation.currentURI.spec;
    } catch(ex) {
      URL = tab.getAttribute("firstpage");
    }
    createCell((i+1), favicon, label, URL, reloadInterval, tab.ordinal);
  }
  updateCurrentIndex();
}
////////////////////////////////////////////////////////////////////////////////
function addContainer(aWindow)
{
  var treeKids = document.getElementById("tabList");
  var item     = document.createElement("treeitem");
  var children = document.createElement("treechildren");

  item.setAttribute("container", "true");
  item.setAttribute("open", "true");
  item.setAttribute("primary", "false");
  // item.setAttribute("label", aWindow);
  children.setAttribute("id", "window-0");
  item.appendChild(children);
  treeKids.appendChild(item);
}
////////////////////////////////////////////////////////////////////////////////
function createCell(aNumber, aImage, aLabel, aURL, aReloadInterval, aOrdinal)
{
  var treeKids = document.getElementById("tabList");
  var row      = document.createElement("treerow");
  var tab      = document.createElement("treecell");
  var label    = document.createElement("treecell");
  var image    = document.createElement("treecell");
  var URL      = document.createElement("treecell");
  var interval = document.createElement("treecell");
  var ordinal  = document.createElement("treecell");
  var item     = document.createElement("treeitem");

  tab.setAttribute("label", aNumber);
  label.setAttribute("label", aLabel);
  // label.setAttribute("src", aImage);
  image.setAttribute("src", aImage);
  URL.setAttribute("label", aURL);
  interval.setAttribute("label", aReloadInterval);
  ordinal.setAttribute("label", aOrdinal);
  
  row.appendChild(tab);
  row.appendChild(label);
  row.appendChild(image);
  row.appendChild(URL);
  row.appendChild(interval);
  row.appendChild(ordinal);

  item.setAttribute("id", "tm-tab-"+aNumber);
  item.appendChild(row);

  treeKids.appendChild(item);
}
////////////////////////////////////////////////////////////////////////////////
function updateCurrentIndex()
{
  tree.currentIndex = tabbrowser.selectedTab.ordinal;
  tree.treeBoxObject.selection.toggleSelect(tree.currentIndex);
}
////////////////////////////////////////////////////////////////////////////////
function activateSelectedTab()
{
  var tabs = getSelectedTreeItems();
  if (tabs && tabs.length == 1) {
    tabbrowser.selectedTab = tabs[0];
    tree.selectedItem = tabs[0].ordinal;
  }
  // setTimeout("tree.focus()", 0); // Hack to prevent main browser window to steal focus!
}
////////////////////////////////////////////////////////////////////////////////
function onHelp()
{
  var tabManagerHelpURL = stringBundle.getString("helpPages-TabManager");
  // We could eventually check the on-line status!
  tabbrowser.loadURI(tabManagerHelpURL);
  window.close();
}
////////////////////////////////////////////////////////////////////////////////
function onCancel()
{
  window.close();
}
////////////////////////////////////////////////////////////////////////////////
function onAccept()
{
  var tabs = getSelectedTreeItems();
  if (tabs && tabs.length > 1)
    doRemove();
  else
    activateSelectedTab();
  window.close();
}
////////////////////////////////////////////////////////////////////////////////
function doSelect(aSelection)
{
  switch (aSelection) {
    case "all": // Called from the context menu, or Ctrl+A ?
         tree.treeBoxObject.selection.selectAll();
         break;
    case "none": // Called from the context menu, or Ctrl+Z ?
         tree.treeBoxObject.selection.clearSelection();
         tree.treeBoxObject.selection.select(tree.currentIndex);
         break;
  }
  tree.focus();
}
////////////////////////////////////////////////////////////////////////////////
function getSelectedTreeItems()
{
  var t = -1;
  var tabs = new Array();
  // Get and return all selection ranges
  var rangeCount = tree.treeBoxObject.selection.getRangeCount();
  // Itterate over all ranges to collect the selected items
  for (var i = 0; i < rangeCount; i++) {
    var startSelection = {};
    var endSelection = {};
    tree.treeBoxObject.selection.getRangeAt(i, startSelection, endSelection);
    // Collect all items and store them in our array
    for (var l = startSelection.value; l <= endSelection.value; l++) {
      var index = tree.view.getCellText(l, "tm-ordinal");
      tabs[++t] = tabbrowser.mTabList[index];
      // dump("range: "+i+"loop: "+l+"tab: "+t"\n");
    }
  }
  if (tabs)
    return tabs;
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function doRemove(aSelection)
{
  var confirmationType = (aSelection == "all") ? "multiple" : "single";
  // Do we have to do select items first (this is done from the context menu)?
  if (aSelection)
    doSelect(aSelection);
  // Collect the selected items
  var tabs = getSelectedTreeItems();
  // Do we have a selected tab?
  if (tabs && tabs.length > 0) {
    // Ask for confirmation before performing the destructive task
    if (!confirmClose(confirmationType)) {
      tree.focus();
      return;
    }
    // Confirmed by user, close the tab/tabs one after one
    for (var i = (tabs.length-1); i > -1; i--)
      tabbrowser.removeTab(tabs[i]);
    tabs = null;
    window.close(); // must be replace with some sort of update window tree thing!
  }
}
////////////////////////////////////////////////////////////////////////////////
function closeTab()
{
  if (confirmClose("single")) {
    tabbrowser.removeTab(tabbrowser.selectedTab);
    window.close(); // must be replace with some sort of update window tree thing!
  }
}
////////////////////////////////////////////////////////////////////////////////
function confirmClose(allFlag)
{
  var confirmationState = false;
  var confirmDialogTitle = (allFlag == "single") ? "tab.confirmDialogTitle" : "tabs.confirmDialogTitle";
  var confirmDialogText = (allFlag == "single") ? "tab.confirmDialogText" : "tabs.confirmDialogText";

  if (tabbrowser.confirm(confirmDialogTitle, confirmDialogText))
    confirmationState =  true;
  tree.focus();
  return confirmationState;
}
////////////////////////////////////////////////////////////////////////////////
function initContextMenu()
{
  var rows = tree.treeBoxObject.view.rowCount;
  var selectedItems = getSelectedTreeItems();

  // Disable "Select All" when there's a selection - note: "Close All Tabs use <observes/> to synchronize
  // Disable "Deselect All" when there's no selection
  var selectAll = document.getElementById("tmc-select-tabs");
  var deselectAll = document.getElementById("tmc-undoSelection");
  if (selectedItems.length > 1) {
    selectAll.setAttribute("disabled", "true");
    deselectAll.removeAttribute("disabled");
  }
  else { // No selection, enable "Select All" and disable "Deselect All"
    if (rows > 1)
      selectAll.removeAttribute("disabled");
    deselectAll.setAttribute("disabled", "true");
  }
  // Disable "Reload Tab Every" for blank tabs
  var browser = tabbrowser.getBrowserForTab(tabbrowser.selectedTab);
  var autoReloadMenu = document.getElementById("tmc-set-interval");
  if (browser.currentURI.spec == "about:blank")
    autoReloadMenu.setAttribute("disabled", "true");
  else autoReloadMenu.removeAttribute("disabled");

  // Display/hide reload indicator
  if (tabbrowser.selectedTab.mReloadInterval)
    autoReloadMenu.setAttribute("tab-will-reload", "true");
  else
    autoReloadMenu.removeAttribute("tab-will-reload");

  // Disable "Close All Tabs" when there's only one tab
  var closeAllTabs = document.getElementById("tmc-close-all-tabs");
  if (rows > 1)
    closeAllTabs.removeAttribute("disabled");
  else closeAllTabs.setAttribute("disabled", "true");
}
////////////////////////////////////////////////////////////////////////////////
//  Work in progress here, doesn't work yet, planned for a next update
var tabManagerDNDObserver = 
{
  tree : null,
  
  initTabManagerDNDObserver: function()
  {
    tree = document.getElementById("tabManagerTree");
    /* initializeRDFStorageFile();
    tree.database.AddDataSource(mzRDFStore);
    tree.builder.rebuild();
    updateCurrentIndex(); */
    tabbrowser = getLastActiveBrowserWindow().getBrowser();
    stringBundle = document.getElementById("tm-properties");
    tabListInit();
  },

  onDragStart: function(aEvent, aXferData, aDragSession)
  {
    // start the row drag operation only when there are at least 2 visible rows
    if (tree.treeBoxObject.view.rowCount > 1) {
      aEvent.target.setAttribute("dragover", "true");
      var ordinal = tree.view.getCellText(tree.currentIndex, "tm-ordinal");
      // dump("onDragStart ordinal: "+ordinal+"\n");
      aXferData.data = new TransferData();
      aXferData.data.addDataForFlavour("text/unicode", ordinal);
    }
  },

  onDragOver: function(aEvent, aXferData, aDragSession)
  {
    var X = aEvent.pageX;
    var Y = aEvent.pageY;
    var row = tree.treeBoxObject.getRowAt(X, Y);

    aDragSession.canDrop = true;
    if (row > -1) {
      dump("onDragOver - row: "+row+"\n");
      var ordinal = tree.view.getCellText(row, "tm-ordinal");
      dump("ordinal: "+ordinal+"\n");
      ordinal++;
      var element = document.getElementById("tm-tab-"+ordinal);
      dump(element.nodeName+"\n");
      // nsDragAndDrop.mDragSession.sourceNode = element;
    }
  },

  onDrop: function(aEvent, aXferData, aDragSession)
  {
    dump("onDrop\n"+aEvent.originalTarget.nodeName);
  },

  onDragExit: function(aEvent, aXferData, aDragSession)
  {
    tree.childNodes[1].removeAttribute("dragover");
  },

  getSupportedFlavours: function ()
  {
    // we might want to expand this
    var flavourSet = new FlavourSet();
    flavourSet.appendFlavour("text/unicode");
    return flavourSet;
  },

  canDrop: function (aEvent, aDragSession)
  {
    aDragSession.canDrop = true;
    // allow drops from the Tab Manager only
    var doc = aDragSession.sourceNode.ownerDocument;
    var elem = doc.getElementById("tabManagerWindow");
    return (elem && (elem.getAttribute("windowtype") == "multizilla:tabmanager"));
  } 
};

  // http://lxr.mozilla.org/seamonkey/source/layout/xul/base/src/tree/public/nsITreeSelection.idl#108
  // if (tree.treeBoxObject.selection.single) alert("single");
  // alert(tree.treeBoxObject.selection.count); // seltype="single"
  // if (tree.treeBoxObject.selection.isSelected(tree.currentIndex)) alert("isSelected");
  // tree.treeBoxObject.selection.select(1); // seltype="single"
  // tree.treeBoxObject.selection.timedSelect(2, 500);
  // tree.treeBoxObject.selection.toggleSelect(tree.currentIndex);
  // tree.treeBoxObject.selection.rangedSelect(0, 4, false); // seltype="multiple"
  // tree.treeBoxObject.selection.clearRange(1, 3); seltype="multiple"
  // tree.treeBoxObject.selection.clearSelection(); // for a single row

  /* tree.treeBoxObject.selection.invertSelection();
  Error: [Exception... "Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsITreeSelection.invertSelection]"  nsresult: "0x80004001 (NS_ERROR_NOT_IMPLEMENTED)"  location: "JS frame :: chrome://multiviews/content/multiviewsTabList.js :: updateCurrentIndex :: line 102"  data: no]
  Source File: chrome://multiviews/content/multiviewsTabList.js
  Line: 102 
  See bug: http://bugzilla.mozilla.org/show_bug.cgi?id=216339 */

  // tree.treeBoxObject.selection.selectAll(); // seltype="multiple"
  // alert(tree.treeBoxObject.selection.getRangeCount()); seltype="multiple"
  // alert(tree.treeBoxObject.selection.getRangeAt(0, out long min, out long max));
  // tree.treeBoxObject.selection.invalidateSelection();
  // tree.treeBoxObject.selection.adjustSelection(2, 4); seltype="multiple"
  // alert(tree.treeBoxObject.selection.selectEventsSuppressed);
  // alert(tree.treeBoxObject.selection.currentIndex);
  // alert(tree.treeBoxObject.selection.shiftSelectPivot);

  // http://lxr.mozilla.org/seamonkey/source/layout/xul/base/src/tree/public/nsITreeBoxObject.idl#110
  // http://lxr.mozilla.org/seamonkey/source/layout/xul/base/src/tree/public/nsITreeView.idl#119
  // alert(tree.treeBoxObject.view.canDropOn(0));
  // alert(tree.treeBoxObject.view.canDropBeforeAfter (0, false));

addEventListener("load", tabManagerDNDObserver.initTabManagerDNDObserver, false);